/*
CGI.cc
*/

#include "CGI.h"

CGI::CGI (char *UPLOADBASEDIRATTACHS)
  {
  CodeUpload = 0;
  beginmailbox = NULL;
  stcmd = NULL;
  stsubcmd = NULL;
  stlang= NULL;
  user  = NULL;
  connid= NULL;
  validator = NULL;
  parm1 = NULL;
  parm2 = NULL;
  parm3 = NULL;
  parm4 = NULL; 
  Num_Cookies = parse_cookies (&cookies);
  CodeUpload = read_cgi_input(&entries, UPLOADBASEDIRATTACHS);
  stcmd      = GetEntry("cmd");
  stsubcmd   = GetEntry("subcmd");
  beginmailbox = GetEntry("beginmailbox");
  stlang     = GetEntry("lang");
  user       = GetEntry("user");
  connid     = GetEntry("connid");
  validator  = GetEntry("validator");
  pageid     = GetEntry("pageid");
  lastcmd    = GetEntry("lastcmd");
  parm1      = GetEntry("parm1");
  parm2      = GetEntry("parm2");
  parm3      = GetEntry("parm3");
  parm4      = GetEntry("parm4");
  if ((strcmp (stcmd,  "") == 0)  || (stcmd == NULL))
    {
    Parse_PATH_INFO (getenv("PATH_INFO"));
    }
  }      
  
int CGI::getNumCookies (void)
  {
  return Num_Cookies;
  }
  
char *CGI::get_Cookie (char *id)
  {
  node *window;
  int cont;
  cont = 1;
  window = cookies.head;
  if ((window == NULL) || (id == NULL)) {return "";}
  while ((window != NULL) && (cont < 10))
    {
    ++cont;
    if (strcmp (window->entry.name, id) == 0) {return xstrdup (window->entry.value);}
    window = window->next;
    }
  return "";  
  }
       
char *CGI::get_PATHINFO (void)
  {
  char *buffer = getenv("PATH_INFO");  
  if (buffer == NULL) return "";
  return xstrdup(buffer);      
  }   
  
int CGI::getCodeUpload (void)
  {
  return CodeUpload;
  }           

CGI::~CGI ()
  {
  list_clear (&cookies);
  list_clear(&entries);
  if (THEPATH_INFO != NULL) free (THEPATH_INFO);
  if (stcmd != NULL)     free (stcmd);
  if (stsubcmd != NULL)  free (stsubcmd);
  if (stlang!= NULL)     free (stlang);
  if (user != NULL)      free (user);
  if (beginmailbox != NULL)      free (beginmailbox);
  if (connid != NULL)    free (connid);
  if (validator != NULL) free (validator);
  if (pageid != NULL)    free (pageid);
  if (lastcmd != NULL)   free (lastcmd);
  if (parm1 != NULL)     free (parm1);
  if (parm2 != NULL)     free (parm2);
  if (parm3 != NULL)     free (parm3);
  if (parm4 != NULL)     free (parm4);   
  }
  
char *CGI::GetEntry (char *name)
  {
  if (cgi_val (entries, name) == NULL) return "";
  else return cgi_val (entries, name);
  } 
  
char *CGI::GetMultipleEntries (char *name, char *SEP)
  {
  TBuffer abuf;
  int i;
  char **mat, *pc;
  abuf[0] = '\0';
  mat = cgi_val_multi (entries, name);
  if (mat != NULL)
    {
    i = 0;
    pc = mat[i];
    while (pc != NULL)
      {
      if (strlen(abuf) + strlen(mat[i]) + 1 < CMAXBUFFER) {strcat (abuf, mat[i]); strcat (abuf, SEP);}
      ++i;
      pc = mat[i];
      }
    abuf[strlen(abuf) - 1] = '\0';  
    } 
  else strncpy (abuf, " ", CMAXBUFFER);  
  return xstrdup(abuf);
  }   
  
char *CGI::GetEntryDef (char *name, char *def)
  {
  char *pc;
  pc = cgi_val (entries, name);
  if (pc == NULL) 
    {
    return xstrdup(def);
    }
  else 
    {
    if (strcmp(pc, "") == 0) 
      {
      return xstrdup(def);
      }
    else 
      {
      return pc;
      }
    }
  } 
  
bool CGI::IsNullEntry (char *name)
  {
  return !is_field_exists (entries, name);
  }
  
bool CGI::GetEntryBool (char *name)
  {
  char *pc;
  pc = cgi_val (entries, name);
  if (pc == NULL) 
    {
    return false;
    }
  else 
    {
    if (strcmp(pc, "") == 0) 
      {
      return false;
      }
    else 
      {
      return true;
      }
    }
  } 
    
void CGI::PrintAllEntries()
  {
  printf ("Content-type: text/html\n\n");
  print_cgi_env ();
  print_entries (entries);
  exit (0);
  }

void CGI::Parse_PATH_INFO (char *apath)
  {
  int numtoken;
  TBuffer token;
  char letra[2];
  //THEPATH_INFO = /cmd/spa/noprotes/xdsd4565643ghgt/save/move/list/1
  //1.stcmd, 2.stsubcmd, 3.stlang, 4.user, 5.connid, 6.validator, 7.pageid, 8.lastcmd
  //     9.parm1, 10.parm2, 11.parm3, 12.parm4
  if (apath == NULL) THEPATH_INFO = xstrdup("/");
  else THEPATH_INFO = xstrdup(apath);
  numtoken = 0; initStr (token); letra[1] = '\0';
  for (xuint i=0; i<strlen(THEPATH_INFO); ++i)
    {
    char c;
    c = THEPATH_INFO[i];
    switch (c) 
      {
      case '/':
        {
        ++numtoken;
        if (numtoken > 1)
          {
          switch (numtoken)
            {
            case 2: if ((strcmp (stcmd,  "") == 0) || (stcmd == NULL)) 
                       stcmd=  xstrdup (token); break;                 
            case 3: if ((strcmp (stsubcmd,  "") == 0) || (stsubcmd == NULL)) 
                       stsubcmd=  xstrdup (token); break;                 
            case 4: if ((strcmp (stlang, "") == 0) || (stlang == NULL))  
                       stlang= xstrdup (token); break;
            case 5: if ((strcmp (user,   "") == 0) || (user == NULL))  
                       user=   xstrdup (token); break;
            case 6: if ((strcmp (connid, "") == 0) || (connid == NULL))  
                       connid= xstrdup (token); break;
            case 7: if ((strcmp (validator, "") == 0) || (validator == NULL))  
                       validator= xstrdup (token); break;
            case 8: if ((strcmp (pageid, "") == 0) || (pageid == NULL))  
                       pageid= xstrdup (token); break;     
            case 9: if ((strcmp (lastcmd, "") == 0) || (lastcmd == NULL))  
                       lastcmd= xstrdup (token); break;                            
            case 10:if ((strcmp (parm1,  "") == 0) || (parm1 == NULL))
                       parm1=  xstrdup (token); break;
            case 11:if ((strcmp (parm2,  "") == 0) || (parm2 == NULL))  
                       parm2=  xstrdup (token); break;
            case 12:if ((strcmp (parm3,  "") == 0) || (parm3 == NULL))  
                       parm3=  xstrdup (token); break;
            case 13:if ((strcmp (parm4,  "") == 0) || (parm4 == NULL))  
                       parm4=  xstrdup (token); break;
            }
          initStr (token);
          }
        break;
        }
      default:
        {
        letra[0] = c;
        strcat (token, letra);
        break;
        }
      }
    }
  if (strlen(token) > 0)
    {
    ++numtoken;
    if (numtoken > 1)
      {
      switch (numtoken)
        {
        case 2: if ((strcmp (stcmd,  "") == 0)  || (stcmd == NULL))  
                  stcmd = xstrdup (token); break;
        case 3: if ((strcmp (stsubcmd,  "") == 0)  || (stsubcmd == NULL))  
                  stsubcmd = xstrdup (token); break;
        case 4: if ((strcmp (stlang,  "") == 0) || (stlang == NULL))  
                  stlang = xstrdup (token); break;
        case 5: if ((strcmp (user,  "") == 0)   || (user == NULL))     
                  user = xstrdup (token); break;
        case 6: if ((strcmp (connid,  "") == 0) || (connid == NULL))   
                  connid = xstrdup (token); break;
        case 7: if ((strcmp (validator,  "") == 0) || (validator == NULL))   
                 validator = xstrdup (token); break;
        case 8: if ((strcmp (pageid,  "") == 0) || (pageid == NULL))   
                 pageid = xstrdup (token); break;                 
        case 9: if ((strcmp (lastcmd,  "") == 0) || (lastcmd == NULL))   
                 lastcmd = xstrdup (token); break;                         
        case 10: if ((strcmp (parm1,  "") == 0)  || (parm1 == NULL))
                  parm1 = xstrdup (token); break;
        case 11:if ((strcmp (parm2,  "") == 0)  || (parm2 == NULL))    
                  parm2 = xstrdup (token); break;
        case 12:if ((strcmp (parm3,  "") == 0)  || (parm3 == NULL))    
                  parm3 = xstrdup (token); break;
        case 13:if ((strcmp (parm4,  "") == 0)  || (parm4 == NULL))    
                  parm4 = xstrdup (token); break;
        }
      initStr (token);
      }
    }
  }                 
  
char *CGI::getCmd ()
  {
  if (stcmd == NULL) return xstrdup ("");  
  return xstrdup (stcmd);
  } 

char *CGI::getSubCmd ()
  {
  if (stsubcmd == NULL) return xstrdup ("");  
  return xstrdup (stsubcmd);
  } 
  
char *CGI::getLang ()
  {
  if (stlang == NULL) return xstrdup ("eng");
  if (strcmp (stlang,  "") == 0) return xstrdup ("eng");
  return xstrdup (stlang);
  }   
  
char *CGI::getUser ()
  {
  if (user == NULL) return xstrdup ("");
  return xstrdup (user);
  } 

char *CGI::getConnid ()
  {
  if (connid == NULL) return xstrdup ("-1");
  if (strcmp (connid,  "") == 0) return xstrdup ("-1");  
  return xstrdup (connid);
  } 

char *CGI::getValidator ()
  {
  if (validator == NULL) return xstrdup ("-1");
  if (strcmp (validator,  "") == 0) return xstrdup ("-1");  
  if (xatoidef (validator, -1) == -1) return xstrdup ("-1");
  return xstrdup (validator);
  } 
  
char *CGI::getPageId ()
  {
  if (pageid == NULL) return xstrdup ("-1");
  if (strcmp (pageid,  "") == 0) return xstrdup ("-1");  
  if (xatoidef (pageid, -1) == -1) return xstrdup ("-1");
  return xstrdup (pageid);
  }   
  
char *CGI::getLastCmd ()
  {
  if (lastcmd == NULL) return xstrdup ("-1");
  if (strcmp (lastcmd,  "") == 0) return xstrdup ("-1");  
  if (xatoidef (lastcmd, -1) == -1) return xstrdup ("-1");
  return xstrdup (lastcmd);
  }     

char *CGI::getParm1 ()
  {
  if (parm1 == NULL) return xstrdup ("");
  return xstrdup (parm1);
  } 

char *CGI::getParm2 ()
  {
  if (parm2 == NULL) return xstrdup ("");  
  return xstrdup (parm2);
  } 

char *CGI::getParm3 ()
  {
  if (parm3 == NULL) return xstrdup ("");  
  return xstrdup (parm3);
  } 

char *CGI::getParm4 ()
  {
  if (parm4 == NULL) return xstrdup ("");  
  return xstrdup (parm4);
  }   
  
    
char *CGI::get_REMOTE_ADDR (char *def)
  {
  char *buffer = getenv("REMOTE_ADDR");  
  if (buffer == NULL) return xstrdup(def);
  return xstrdup(buffer);
  }

char *CGI::get_COOKIE (void)
  {
  char *buffer = getenv("COOKIE");  
  if (buffer == NULL) return xstrdup("");
  return xstrdup(buffer);
  }

