/*                               
Utils.cc
*/

#include "Utils.h"
#include "Language.h"

extern Language *L;
extern int errno;

void initStr (char *thestr)
  {
  thestr [0] = '\0';
  }

void initStr (char *thestr, const char *consstr)
  {
  strcpy (thestr, consstr);
  }

int TranslateCmd (const char *stcmd)
  {
  if (IsEmpty(stcmd)) return CMD_HOME;
  TBuffer uplinea;
  strncpy (uplinea, stcmd, CMAXBUFFER); xucase (uplinea);
  if (IsEmpty(uplinea)                   == true) {return CMD_HOME;}
  if (strcmp (uplinea, "CHECK_COOKIE")   == 0)    {return CMD_CHECK_COOKIE;}  
  if (strcmp (uplinea, "CONF_ACT")       == 0)    {return CMD_CONF_ACT;}
  if (strcmp (uplinea, "HOME")           == 0)    {return CMD_HOME;}
  if (strcmp (uplinea, "LOGIN")          == 0)    {return CMD_LOGIN;}
  if (strcmp (uplinea, "LOGOUT")         == 0)    {return CMD_LOGOUT;}
  if (strcmp (uplinea, "HELP")           == 0)    {return CMD_HELP;}
  if (strcmp (uplinea, "MG_DUMPFULLMSG") == 0)    {return CMD_MG_DUMPFULLMSG;}
  if (strcmp (uplinea, "MG_DUMPFULLHEADER") == 0)    {return CMD_MG_DUMPFULLHEADER;} 
  if (strcmp (uplinea, "MG_DISPLAY")     == 0)    {return CMD_MG_DISPLAY;}
  if (strcmp (uplinea, "MG_COPY")        == 0)    {return CMD_MG_COPY;}
  if (strcmp (uplinea, "MG_MOVE")        == 0)    {return CMD_MG_MOVE;}
  if (strcmp (uplinea, "MG_DELDISPLAY")  == 0)    {return CMD_MG_DELDISPLAY;}
  if (strcmp (uplinea, "MG_UNDELDISPLAY")== 0)    {return CMD_MG_UNDELDISPLAY;}  
  if (strcmp (uplinea, "MB_INDEX")       == 0)    {return CMD_MB_INDEX;}
  if (strcmp (uplinea, "MB_SHOW")        == 0)    {return CMD_MB_SHOW;}
  if (strcmp (uplinea, "MB_CHANGE")      == 0)    {return CMD_MB_CHANGE;}
  if (strcmp (uplinea, "MB_CREATE")      == 0)    {return CMD_MB_CREATE;}
  if (strcmp (uplinea, "MB_DELETE")      == 0)    {return CMD_MB_DELETE;}
  if (strcmp (uplinea, "MB_RENAME")      == 0)    {return CMD_MB_RENAME;}
  if (strcmp (uplinea, "MB_EXPUNGE")     == 0)    {return CMD_MB_EXPUNGE;}
  if (strcmp (uplinea, "MB_DUMP")        == 0)    {return CMD_MB_DUMP;}  
  if (strcmp (uplinea, "MB_SEARCH")      == 0)    {return CMD_MB_SEARCH;}    
  if (strcmp (uplinea, "FG_DELETE")      == 0)    {return CMD_FG_DELETE;}
  if (strcmp (uplinea, "FG_UNDELETE")    == 0)    {return CMD_FG_UNDELETE;}
  if (strcmp (uplinea, "FG_ANSWERED")    == 0)    {return CMD_FG_ANSWERED;}
  if (strcmp (uplinea, "FG_UNANSWERED")  == 0)    {return CMD_FG_UNANSWERED;}
  if (strcmp (uplinea, "FG_FLAGGED")     == 0)    {return CMD_FG_FLAGGED;}
  if (strcmp (uplinea, "FG_UNFLAGGED")   == 0)    {return CMD_FG_UNFLAGGED;}
  if (strcmp (uplinea, "FG_SEEN")        == 0)    {return CMD_FG_SEEN;}
  if (strcmp (uplinea, "FG_UNSEEN")      == 0)    {return CMD_FG_UNSEEN;}
  if (strcmp (uplinea, "CM")             == 0)    {return CMD_CM;}
  if (strcmp (uplinea, "CMNNTP")         == 0)    {return CMD_CMNNTP;}  
  if (strcmp (uplinea, "CM_SEND")        == 0)    {return CMD_CM_SEND;}
  if (strcmp (uplinea, "CM_SENDNNTP")    == 0)    {return CMD_CM_SENDNNTP;}  
  if (strcmp (uplinea, "CM_CANCEL")      == 0)    {return CMD_CM_CANCEL;}
  if (strcmp (uplinea, "CM_REPLY")       == 0)    {return CMD_CM_REPLY;}
  if (strcmp (uplinea, "CM_REPLYALL")    == 0)    {return CMD_CM_REPLYALL;}
  if (strcmp (uplinea, "CM_REPLYGROUP")  == 0)    {return CMD_CM_REPLYGROUP;}  
  if (strcmp (uplinea, "CM_FORWARD")     == 0)    {return CMD_CM_FORWARD;}
  if (strcmp (uplinea, "CM_CLEANALL")    == 0)    {return CMD_CM_CLEANALL;}
  if (strcmp (uplinea, "CM_SAVE")        == 0)    {return CMD_CM_SAVE;}  
  if (strcmp (uplinea, "OP")             == 0)    {return CMD_OP;}
  if (strcmp (uplinea, "OP_CANCEL")      == 0)    {return CMD_OP_CANCEL;}
  if (strcmp (uplinea, "OP_SAVE")        == 0)    {return CMD_OP_SAVE;}
  if (strcmp (uplinea, "AT_SHOW")        == 0)    {return CMD_AT_SHOW;}
  if (strcmp (uplinea, "AT_DUMP")        == 0)    {return CMD_AT_DUMP;}
  if (strcmp (uplinea, "AT_SAVE")        == 0)    {return CMD_AT_SAVE;}  
  if (strcmp (uplinea, "AT_ERASE")       == 0)    {return CMD_AT_ERASE;}
  if (strcmp (uplinea, "AB")             == 0)    {return CMD_AB;}
  if (strcmp (uplinea, "AB_SHOWALL")     == 0)    {return CMD_AB_SHOWALL;}
  if (strcmp (uplinea, "AB_SAVEENTRY")   == 0)    {return CMD_AB_SAVEENTRY;}
  if (strcmp (uplinea, "AB_EDITENTRY")   == 0)    {return CMD_AB_EDITENTRY;}
  if (strcmp (uplinea, "AB_DELEENTRIES") == 0)    {return CMD_AB_DELEENTRIES;}
  if (strcmp (uplinea, "AB_NEWENTRY")    == 0)    {return CMD_AB_NEWENTRY;}
  if (strcmp (uplinea, "AB_SORT")        == 0)    {return CMD_AB_SORT;}
  if (strcmp (uplinea, "AB_FROM_CM")     == 0)    {return CMD_AB_FROM_CM;}
  if (strcmp (uplinea, "AB_TAKEADDRESS") == 0)    {return CMD_AB_TAKEADDRESS;}
  if (strcmp (uplinea, "AB_ADDFIELDS")   == 0)    {return CMD_AB_ADDFIELDS;}  
  if (strcmp (uplinea, "AB_DUMP")        == 0)    {return CMD_AB_DUMP;}  
  if (strcmp (uplinea, "NOOP")           == 0)    {return CMD_NOOP;}    
  if (strcmp (uplinea, "DEBUG")          == 0)    {return CMD_DEBUG;}      
  if (strcmp (uplinea, "MB_SORT")        == 0)    {return CMD_MB_SORT;}        
  if (strcmp (uplinea, "MG_FG_DELETE")    == 0)   {return CMD_MG_FG_DELETE;}        
  if (strcmp (uplinea, "MG_FG_UNDELETE")  == 0)   {return CMD_MG_FG_UNDELETE;}        
  if (strcmp (uplinea, "MG_FG_ANSWERED")  == 0)   {return CMD_MG_FG_ANSWERED;}        
  if (strcmp (uplinea, "MG_FG_UNANSWERED")== 0)   {return CMD_MG_FG_UNANSWERED;}        
  if (strcmp (uplinea, "MG_FG_FLAGGED")   == 0)   {return CMD_MG_FG_FLAGGED;}        
  if (strcmp (uplinea, "MG_FG_UNFLAGGED") == 0)   {return CMD_MG_FG_UNFLAGGED;}        
  if (strcmp (uplinea, "MG_FG_SEEN")      == 0)   {return CMD_MG_FG_SEEN;}        
  if (strcmp (uplinea, "MG_FG_UNSEEN")    == 0)   {return CMD_MG_FG_UNSEEN;}        
  if (strcmp (uplinea, "MG_FG_SEARCHED")  == 0)   {return CMD_MG_FG_SEARCHED;}        
  if (strcmp (uplinea, "MG_FG_UNSEARCHED")== 0)   {return CMD_MG_FG_UNSEARCHED;}          
  if (strcmp (uplinea, "OP_NNTP")            == 0){return CMD_OP_NNTP;}        
  if (strcmp (uplinea, "OP_NNTP_CANCEL")     == 0){return CMD_OP_NNTP_CANCEL;}        
  if (strcmp (uplinea, "OP_NNTP_SAVE")       == 0){return CMD_OP_NNTP_SAVE;}        
  if (strcmp (uplinea, "OP_NNTP_SEARCH")     == 0){return CMD_OP_NNTP_SEARCH;}        
  if (strcmp (uplinea, "OP_NNTP_ADDSELECTED")== 0){return CMD_OP_NNTP_ADDSELECTED;}        
  if (strcmp (uplinea, "BD_UUDECODE")== 0)        {return CMD_BD_UUDECODE;}        
  if (strcmp (uplinea, "NW_LIST_DUMP")== 0)       {return CMD_NW_LIST_DUMP;}
  return CMD_INVALID;                
  }
  
int TranslateHelpCmd (const char *sthelp)
  {
  TBuffer uplinea;
  strncpy (uplinea, sthelp, CMAXBUFFER); xucase (uplinea);
  if (strcmp (uplinea, "")             == 0) {return CMD_HELP_INDEXMAILBOX;}
  if (strcmp (uplinea, "LOGIN")        == 0) {return CMD_HELP_LOGIN;}  
  if (strcmp (uplinea, "MB_INDEX")     == 0) {return CMD_HELP_INDEXMAILBOX;}
  if (strcmp (uplinea, "MG_DISPLAY")   == 0) {return CMD_HELP_DISPLAYMSG;}
  if (strcmp (uplinea, "MB_SHOW")      == 0) {return CMD_HELP_SHOWMAILBOXES;}
  if (strcmp (uplinea, "CM")           == 0) {return CMD_HELP_COMPOSEMSG;}
  if (strcmp (uplinea, "OP")           == 0) {return CMD_HELP_SHOWOPTIONS;}
  if (strcmp (uplinea, "AB")           == 0) {return CMD_HELP_ADDBOOK;}
  if (strcmp (uplinea, "AB_EDITENTRY") == 0) {return CMD_HELP_AB_EDITENTRY;} 
  if (strcmp (uplinea, "AB_NEWENTRY")  == 0) {return CMD_HELP_AB_NEWENTRY;}    
  if (strcmp (uplinea, "AT_SHOW")      == 0) {return CMD_HELP_SHOWATTACHS;}
  if (strcmp (uplinea, "ABOUT")        == 0) {return CMD_HELP_ABOUT;}  
  return CMD_HELP_INDEXMAILBOX;
  }  

void SaveFileDebug (char *fn, char *pc, int len)
  {
  FILE *fw;
  fw = fopen (fn, "w");
  for (int i=0; i<len; ++i) {fprintf (fw, "%c", pc[i]);}
  fclose (fw);
  }
  
void SaveFileDebug (char *fn, char *pc)
  {
  int len;
  len = strlen (pc);
  FILE *fw;
  fw = fopen (fn, "w");
  for (int i=0; i<len; ++i) {fprintf (fw, "%c", pc[i]);}
  fclose (fw);
  }  
  
char *xstrdup (char const *str)
  {
  return (strcpy(new char [strlen(str) + 1], str));
  }

char *ReturnUsersDir (const char *basepath, const char *user, const char *server, TBuffer ABuf)
  {
  sprintf (ABuf, "%s/%s/%c%c/%s", basepath, server, user[0], user[1], user);
  return ABuf;
  }

char *ReturnUserLockFileName (const char *user, TBuffer ABuf)
  {
  sprintf (ABuf, "%s/%s.lock", LOCKSDIR, user);
  return ABuf;
  }

char *getExtensionFromFile (const char *fn)
  {
  if (fn == NULL) return "";
  if (strchr(fn, '.') == NULL) return "";
  if (fn[strlen(fn) - 1] == '.') return "";
  return (strrchr (fn, '.') + 1);
  }  
  
char *ReturnSignatureFileName (const char *basepath, const char *user, const char *server, TBuffer ABuf)
  {
  TBuffer tmpbuf;
  sprintf (ABuf, "%s/%s", ReturnUsersDir(basepath, user, server, tmpbuf), SIGNATURENAME);
  return ABuf;
  }

char *ReturnSubscribedNNGroupsFileName (const char *basepath, const char *user, const char *server, TBuffer ABuf)
  {
  TBuffer tmpbuf;
  sprintf (ABuf, "%s/%s", ReturnUsersDir(basepath, user, server, tmpbuf), SUBSCRIBEDGROUPSNAME);
  return ABuf;
  }

char *ReturnRcNNGroupsFileName (const char *basepath, const char *user, const char *server, TBuffer ABuf)
  {
  TBuffer tmpbuf;
  sprintf (ABuf, "%s/%s", ReturnUsersDir(basepath, user, server, tmpbuf), RCGROUPSNAME);
  return ABuf;
  }

char *ReturnAllNNGroupsFileName (const char *server, TBuffer abuf)
  {
  sprintf (abuf, "%s/%s.allgroups", NETNEWS_PATH, server);
  return abuf;
  }

char *ReturnUserOptionsFileName (const char *basepath, const char *user, const char *server, TBuffer ABuf)
  {
  TBuffer tmpbuf;
  sprintf (ABuf, "%s/%s", ReturnUsersDir(basepath, user, server, tmpbuf), USEROPTIONSNAME);
  return ABuf;
  }
  
char *ReturnUserAddressbookFileName (const char *basepath, const char *user, const char *server, TBuffer ABuf)
  {
  TBuffer tmpbuf;
  sprintf (ABuf, "%s/%s", ReturnUsersDir(basepath, user, server, tmpbuf), USERADDRESSBOOKNAME);
  return ABuf;
  }  
  
char *ReturnUserSavedMsgFileName (const char *basepath, const char *user, const char *server, TBuffer ABuf)
  {
  TBuffer tmpbuf;
  sprintf (ABuf, "%s/%s", ReturnUsersDir(basepath, user, server, tmpbuf), SAVEDINCOMPOSE);
  return ABuf;
  }   
 
char *ReturnUserSavedNNTPMsgFileName (const char *basepath, const char *user, const char *server, TBuffer ABuf)
  {
  TBuffer tmpbuf;
  sprintf (ABuf, "%s/%s", ReturnUsersDir(basepath, user, server, tmpbuf), SAVEDNNTPINCOMPOSE);
  return ABuf;
  }    
 
/*WARNING: this is hard coded en cgi-lib.c 
  If you change this, must change that file*/  
char *ReturnUserAttachsDir (const char *basepath, const char *user, const char *server, TBuffer ABuf)
  {
  TBuffer tmpbuf;
  sprintf (ABuf, "%s/attachs", ReturnUsersDir(basepath, user, server, tmpbuf));
  return ABuf;
  }  
  
bool CreateDir (char *path, mode_t mode)
  {
  int i;
  bool b;
  i = mkdir (path, S_IREAD | S_IWRITE | S_IEXEC);
  if (i == 0) 
    {
    chmod (path, mode); 
    b = true;
    }
  else 
    {
    if (errno == EEXIST) b = true; 
    else 
      {
      TSBuffer abuf;
      initStr (abuf, "ERROR: I can not create the dir ");
      strncat (abuf, path, CSMALLBUFFER - strlen (abuf) - 1);
      LOG (abuf);
      b = false;
      }
    }
  return b;
  }

bool DeleteFile (const char *fname)
  {
  int i;
  i = unlink (fname);
  if (i == 0) return true;
  else 
    {
    TSBuffer abuf;
    sprintf (abuf, "ERROR: I can not delete the file '%s'", fname);
    LOG (abuf);
    return false;
    }
  }

int CreateAndLockFile (char *fn)
  {
  TSBuffer abuf;
  time_t tloc; tloc = 0;
  int fd;
  fd = open (fn, O_WRONLY | O_CREAT, 0600);
  lockf (fd, F_LOCK, 0);
  sprintf (abuf, "%10d\n", getpid());
  write (fd, abuf, strlen(abuf));
  sprintf (abuf, "%20d\n", (xuint)time(&tloc));
  write (fd, abuf, strlen(abuf));
  return fd;
  }
  
void EscribePIDenLockFile (int fd)
  {
  TSBuffer abuf;
  time_t tloc; tloc = 0;
  lseek (fd, (off_t)0, SEEK_SET);  
  sprintf (abuf, "%10d\n", getpid());
  write (fd, abuf, strlen(abuf));
  sprintf (abuf, "%20d\n", (xuint)time(&tloc));
  write (fd, abuf, strlen(abuf));
  }  
  
int IsLocked (char *fn, int *fd)
  {
  int res;
  *fd = open (fn, O_RDWR);
  if (*fd < 0) {return 2;}          //NO EXISTE EL FICHERO
  res = lockf (*fd, F_TLOCK, 0);    //EL TLOCK NO SE ESPERA
  if (res == 0) return 0;           //NO HAY LOCK
  else return 1;                    //SI HAY LOCK
  }   
  
void UnlockAndCloseFile (int fd)
  {
  close (fd);
  }  

int GetPIDFromLockFile (int fd)
  {
  int r;
  char abuf[11];
  lseek (fd, (off_t)0, SEEK_SET);
  read (fd, abuf, 10);
  abuf[10] = '\0';
  r = atoi(abuf);
  return r;
  }

long GetTimeFromLockFile (int fd)
  {
  long r;
  char abuf[21];
  lseek (fd, (off_t)11, SEEK_SET);
  read (fd, abuf, 20);
  abuf[20] = '\0';
  r = xatoldef(abuf, -1);
  return r;
  }

long GetTimeFromLockFileOpening (char *fn)
  {
  if (fn == NULL) return -1;
  long r;
  char abuf[21];
  int fd;
  fd = open (fn, O_RDONLY);
  if (fd == -1) return -1;
  lseek (fd, (off_t)11, SEEK_SET);
  read (fd, abuf, 20);
  close (fd);
  abuf[20] = '\0';
  r = xatoldef(abuf, -1);
  return r;
  }
  
void QuitaRetornoCarroDeLinea (char *linea)
  {
  if (linea == NULL) return;
  if (strcmp (linea, "") == 0) return;  
  if (linea[strlen(linea) - 1] == '\013') linea[strlen(linea) - 1] = '\0';  
  if ((linea[strlen(linea) - 1] != '\n') && (linea[strlen(linea) - 1] != '\r')) return;
  linea[strlen(linea) - 1] = '\0';
  if ((linea[strlen(linea) - 1] != '\n') && (linea[strlen(linea) - 1] != '\r')) return;
  linea[strlen(linea) - 1] = '\0';    
  }

void Randomize ()
  {
  xuint seed;
  time_t tloc;
  tloc = 0;
  seed = (xuint)getpid() + (xuint)time(&tloc);
  srand (seed);
  srandom (seed);
  }  

int Rand (int max)
  {
  int res;
  res = rand() % max + 1;
  return res;
  }
  
bool FileExists (const char *fn) 
  {
  int res;
  struct stat STAT;
  res = stat (fn, &STAT);
  if (res == 0) return true; else return false;
  }          

int FileSize (const char *fn)
  {
  struct stat STAT;
  stat (fn, &STAT);
  return STAT.st_size;
  }  

time_t FileDate (char *fn)
  {
  struct stat STAT;
  stat (fn, &STAT);
  return STAT.st_mtime;
  }  
  
char *xucase (char *s)
  {
  if (s == NULL) return NULL;
  char *t;
  for (t = s; *t; t++) if (!(*t & 0x80) && islower (*t)) *t = toupper (*t);
  return s;           
  }

char *xlcase (char *s)
  {
  if (s == NULL) return NULL;  
  char *t;
  for (t = s; *t; t++) if (!(*t & 0x80) && isupper (*t)) *t = tolower (*t);
  return s;   
  }  
  
  
//CONVIERTE UN INTEGER EN UN PCHAR
char *xitoa (int n, TNumber abuf)
  {
  sprintf (abuf, "%d", n);
  return abuf;
  } 

//CONVIERTE UN LONG EN UN PCHAR
char *xltoa (long n, TNumber abuf)
  {
  sprintf (abuf, "%ld", n);
  return abuf;
  }
  
//CONVIERTE UN PCHAR A INT Y SI ES INVALIDO DEVUELVE EL DEFAULT  
int xatoidef (const char *stnum, int def)
  {
  if (stnum == NULL) return def;
  if (strcmp (stnum, "") == 0) return def;
  int i;
  char *chk;
  i = (int) strtol (stnum, &chk, 10);
  if (*chk != '\0') {return def;}  //BAD INTEGER
  return i;
  } 

//CONVIERTE UN STRING A LONG DANDO UN DEFECTO EN ERROR
long int xatoldef (const char *stnum, long int def)
  {
  if (stnum == NULL) return def;
  if (strcmp (stnum, "") == 0) return def;
  long int i;
  char *chk;
  i = strtol (stnum, &chk, 10);
  if (*chk != '\0') {return def;}  //BAD INTEGER
  return i;
  }

char *make_session_id (const char *server, TBuffer abuf)
  {
  char session_chars[] = ("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789");
  int i, p;
  char rawid[24 + 1], letra[2];
  
  letra[1] = '\0';
  initStr (rawid);
  for (i = 1; i <= 24; ++i)
    {
    p = (int) Rand(62);
    letra[0] = session_chars[p - 1];
    strcat (rawid, letra);
    }
  strcpy (abuf, server); strcat (abuf, "@"); strcat (abuf, rawid);  
  return abuf;
  }

char *extract_server_from_connid (const char *connid, TBuffer Buf)
  {
  int pos;
  pos = Cstrstr (connid, "@");
  if (pos <= 0) {strcpy (Buf, "");}
  else {strncpy (Buf, connid, CMAXBUFFER); Buf[pos - 1] = '\0';}
  return Buf;
  }

char *make_root_socket (TBuffer Buf)
  {
  sprintf (Buf, "%s/%s", UNIX_SOCKETS_PATH, PROGNAME);
  return Buf;
  }
  
char *make_session_socket (char *username, char *connid, TBuffer Buf)
  {
  sprintf (Buf, "%s/%s:%s", SOCK_SESSIONS_PATH, username, connid);
  return Buf;
  }
                    
void ini (char *connid, char *stlang, char *stcmd, char *allparms, char *allparms2,
          char *parm1, char *parm2, char *parm3, char *parm4, char *parm5)
  {
  connid[0]    = '\0';
  stlang[0]    = '\0';
  stcmd[0]     = '\0';
  allparms[0]  = '\0';
  allparms2[0] = '\0';
  parm1[0]     = '\0';
  parm2[0]     = '\0';
  parm3[0]     = '\0';
  parm4[0]     = '\0';
  parm5[0]     = '\0';  
  }            

//DEVUELVE LA POSICION DE UN SUBSTRING EN UN STRING SIN IMPORTAR EL CASE  
int NCstrstr (const char *linea, const char *token)
  {
  int res;
  char *p;
  TBuffer UPlinea, UPtoken;
  strncpy (UPlinea, linea, CMAXBUFFER); xucase (UPlinea);
  strncpy (UPtoken, token, CMAXBUFFER); xucase (UPtoken);
  p = strstr (UPlinea, UPtoken);  if (p == NULL) res = 0;
  else res = p - UPlinea + 1;
  return res;
  }  

//DEVUELVE LA POSICION DE UN SUBSTRING EN UN STRING IMPORTANDO EL CASE  
int Cstrstr (const char *linea, const char *token)
  {
  char *p;  
  p = strstr (linea, token);  
  if (p == NULL) return 0;
  return (p - linea + 1);  
  }

//OPEN THE LOG
void OPENLOG (void)
  {  
  openlog (PROGNAME, XLOGOPTIONS, XLOGFACILITY);
  }                                                 

//CLOSE THE LOG
void CLOSELOG (void)
  {  
  closelog();
  }                                                 

//IMPRIME UN MSG EN EL LOG    
void LOG (long i)
  {
  TNumber anum;
  syslog(XLOGPRIORITY, xltoa(i, anum));
  }  
  
//IMPRIME UN MSG EN EL LOG    
void LOG (char *fmt, ...)
  {
  TBuffer linea;
  va_list args;
  va_start (args, fmt);
  xvsnprintf (linea, CMAXBUFFER, fmt, args);
  syslog(XLOGPRIORITY, linea);
  va_end (args);
  }    
 
//IMPRIME UN MSG EN EL LOG CON LA ETIQUETA DE DEBUG     
void DEBUG (char *fmt, ...)
  {
  TBuffer linea, linea2;
  va_list args;
  va_start (args, fmt);
  xvsnprintf (linea, CMAXBUFFER, fmt, args);
  sprintf (linea2, "DEBUG: '%s'", linea);
  syslog(XLOGPRIORITY, linea2);
  va_end (args);
  }      
  
void DEBUG (int imsg)
  {
  TBuffer l;
  sprintf (l, "DEBUG: '%d'", imsg);
  syslog(XLOGPRIORITY, l);
  }    
  
char *FormatCountBytes (long count, TBuffer abuf)
  {
  TNumber anum;
  char stnum[30], stres[50], stres2[50];
  long L, j;
  strncpy (stnum, xltoa (count, anum), 30);
  L = strlen (stnum);
  if (L <= 3) {initStr (stres, "&#60;1K");}
  else if ((L > 3) && (L <= 6)) 
    {j = (long) ((long)count / (long)1024); if (j == 0) j = 1; strncpy (stres, xltoa(j, anum), 50); strcat(stres, "K");}
  else if ((L > 6) && (L <= 9)) 
    {j = (long) ((long)count / (long)1048576); if (j == 0) j = 1; strncpy (stres, xltoa(j, anum), 50); strcat(stres, "M");}
  else {strncpy (stres, stnum, 50); strcat(stres, "b");}
  if (strlen (stres) == 2) 
    {
    initStr (stres2, "  "); 
    strcat (stres2, stres); 
    strncpy (abuf, stres2, CMAXBUFFER); 
    return abuf;
    }
  else if (strlen (stres) == 3) 
    {
    initStr (stres2, " "); 
    strcat (stres2, stres); 
    strncpy (abuf, stres2, CMAXBUFFER);
    return abuf;
    }
  strncpy (abuf, stres, CMAXBUFFER);  
  return abuf;
  }

char *FormatCountBytes1Dec (long count, TBuffer abuf)
  {
  TNumber anum;
  char stnum[30], stres[50];
  long L;
  float f;
  strncpy (stnum, xltoa (count, anum), 30);
  L = strlen (stnum);
  if (L <= 3) {initStr (stres, "&#60;1.0 Kb");}
  else if ((L > 3) && (L <= 6)) 
    {f = (float)count / (float)1024.0;    if (f == 0.0) f = 1.0; sprintf (stres, "%.1f", f); strcat(stres, " Kb");}
  else if ((L > 6) && (L <= 9)) 
    {f = (float)count / (float)1048576.0; if (f == 0.0) f = 1.0; sprintf (stres, "%.1f", f); strcat(stres, " Mb");}
  else {strncpy (stres, stnum, 50); strcat(stres, " b");}
  strncpy (abuf, stres, CMAXBUFFER);
  return abuf;
  }

void Redirect (const char *newurl)
  {
  printf ("Status: 302 Moved\n");
  printf ("Location: %s\n", newurl);
  printf ("Content-Type: text/html\n\n");
  }  

void ErrorPage (const char *error)
  {        
  printf ("Content-type: text/html\n\n");  
  printf ("%s\n<HTML>\n", HTML_DOCTYPE);
  printf ("<HEAD>\n");
  printf ("<TITLE>%s</TITLE>", L->get(L_ERROR));
  printf ("</HEAD>\n");
  printf ("<BODY background=\"%s\" text=\"%s\" bgcolor=\"%s\" link=\"%s\" vlink=\"%s\" alink=\"%s\">\n", 
          DEFIMG_BG, TXTCOLOR, BGCOLOR, BLUE, BLUE2, RED);
  printf ("<p><h1><FONT color=\"%s\">%s:</font> %s</h1><p>\n", RED, L->get(L_ERROR), error);
  printf ("<HR noshade size=2>\n");
  printf ("<SMALL>%s</SMALL>\n", L->get (L_COPYRIGHT));
  printf ("</BODY>\n");
  printf ("</HTML>\n");    
  } 

void CGIErrorPageConnectionRefused (const char *lang)
  {        
  printf ("Content-type: text/html\n\n");  
  printf ("%s\n<HTML>\n", HTML_DOCTYPE);
  printf ("<HEAD>\n");
  printf ("<TITLE>%s</TITLE>", L->get(L_ERROR));
  printf ("</HEAD>\n");
  printf ("<BODY background=\"%s\" text=\"%s\" bgcolor=\"%s\" link=\"%s\" vlink=\"%s\" alink=\"%s\">\n", 
          DEFIMG_BG, TXTCOLOR, BGCOLOR, BLUE, BLUE2, RED);
  printf ("<p><h1><FONT color=\"%s\">%s:</font> %s</h1><p>\n",  RED, L->get(L_ERROR), L->get(MSG_CONNREFUSED));
  printf ("<p>%s<BR>", L->get(MSG_SERVERISDOWN));
  printf ("%s", L->get(MSG_PERHAPSTIMEOUT));
  printf ("<p><A HREF=\"%s?lang=%s\">%s</A>", PATH_POSTMAN, lang, L->get(MSG_CANRECONNECTHERE));
  printf ("<HR noshade size=2>\n");
  printf ("<SMALL>%s</SMALL>\n", L->get (L_COPYRIGHT));
  printf ("</BODY>\n");
  printf ("</HTML>\n");    
  exit (0);
  }

void PrintHelpPage (char *topic)
  {
  int helpcmd;
  helpcmd = TranslateHelpCmd (topic);
  switch (helpcmd)
    {
    case CMD_HELP_LOGIN:
      Redirect(L->getPage(CMD_HELP_LOGIN));
      break;
    case CMD_HELP_INDEXMAILBOX:
      Redirect(L->getPage(CMD_HELP_INDEXMAILBOX));
      break;
    case CMD_HELP_DISPLAYMSG:
      Redirect(L->getPage(CMD_HELP_DISPLAYMSG));
      break;
    case CMD_HELP_SHOWMAILBOXES:
      Redirect(L->getPage(CMD_HELP_SHOWMAILBOXES));
      break;      
    case CMD_HELP_COMPOSEMSG:
      Redirect(L->getPage(CMD_HELP_COMPOSEMSG));
      break;      
    case CMD_HELP_SHOWOPTIONS:
      Redirect(L->getPage(CMD_HELP_SHOWOPTIONS));
      break;            
    case CMD_HELP_ADDBOOK:
      Redirect(L->getPage(CMD_HELP_ADDBOOK));
      break;            
    case CMD_HELP_SHOWATTACHS:
      Redirect(L->getPage(CMD_HELP_SHOWATTACHS));
      break;                        
    case CMD_HELP_ABOUT:
      Redirect(L->getPage(CMD_HELP_ABOUT));
      break;                                          
    case CMD_HELP_AB_NEWENTRY:
      Redirect(L->getPage(CMD_HELP_AB_NEWENTRY));
      break;                                   
    case CMD_HELP_AB_EDITENTRY:
      Redirect(L->getPage(CMD_HELP_AB_EDITENTRY));
      break;                                   
    default: 
      Redirect(L->getPage(CMD_HELP_LOGIN));
      break;
    }
  }
      
//COPIA UN FICHERO, SI EL NUEVO EXISTE NO LO HACE Y DEVUELVE FALSE
bool CopyFile (char *oldfile, char *newfile)
  {
  if (FileExists (newfile) == true) return false;
  char buffer[CMAXBUFFER];
  FILE *FR, *FW;   
  int sz, leido, res1, res2; 
  sz = FileSize (oldfile);
  FR = fopen (oldfile, "r"); FW = fopen (newfile, "w");
  if ((FR == NULL) || (FW == NULL)) return false;
  int totalleido = 0, porleer;
  bool PRIMER = false;
  while (!feof(FR) && (PRIMER == false))
    {
    if (totalleido + CMAXBUFFER <= sz) porleer = CMAXBUFFER;
    else {porleer = sz - totalleido; PRIMER = true;}
    leido = fread (buffer, 1, porleer, FR);
    totalleido += leido;
    fwrite (buffer, 1, (int)leido, FW);
    }
  res1 = fclose (FR);  
  res2 = fclose (FW);
  if ((res1 == EOF) || (res2 == EOF)) return false;
  return true;
  }  

//COPIA UN FICHERO, SI EL NUEVO EXISTE LO SOBRESCRIBE
bool CopyFileOverWrite (const char *oldfile, const char *newfile)
  {
  if (FileExists (newfile) == true) DeleteFile (newfile);
  char buffer[CMAXBUFFER];
  FILE *FR, *FW;   
  int sz, leido, res1, res2; 
  sz = FileSize (oldfile);
  FR = fopen (oldfile, "r"); FW = fopen (newfile, "w");
  if ((FR == NULL) || (FW == NULL)) return false;
  int totalleido = 0, porleer;
  bool PRIMER = false;
  while (!feof(FR) && (PRIMER == false))
    {
    if (totalleido + CMAXBUFFER <= sz) porleer = CMAXBUFFER;
    else {porleer = sz - totalleido; PRIMER = true;}
    leido = fread (buffer, 1, porleer, FR);
    totalleido += leido;
    fwrite (buffer, 1, (int)leido, FW);
    }
  res1 = fclose (FR);  
  res2 = fclose (FW);
  if ((res1 == EOF) || (res2 == EOF)) return false;
  return true;
  }    
  
char *HTML2text (const char *ast, char *res)
  {
  if (ast == NULL) return res;
  long L, LENORIG, LENNEW, SIZENEW;
  const int INCMEM = 1001;
  char c, letra[2], *pc;
  letra[1] = '\0';
  LENNEW = 0;
  SIZENEW = strlen(ast) + INCMEM;
  pc = (char *) malloc ((uint)SIZENEW);
  pc[0] = '\0';
  
  LENORIG = strlen (ast);
  for (L=0; L < LENORIG; ++L)
    {
    c = ast[L];
    switch (c)
      {                              
      case '\010':  //\n _J
        break;  
      case '\013':  //\r _M
        LENNEW = LENNEW + strlen (HTML_CR);
        if (LENNEW >= SIZENEW) {SIZENEW = SIZENEW + INCMEM; pc = (char *)realloc (pc, (uint)SIZENEW);}
        strcat (pc, HTML_CR);
        break;  
      case '>':
        LENNEW = LENNEW + strlen (HTML_MAYOR);
        if (LENNEW >= SIZENEW) {SIZENEW = SIZENEW + INCMEM; pc = (char *)realloc (pc, (uint)SIZENEW);}
        strcat (pc, HTML_MAYOR);
        break;
      case '<':
        LENNEW = LENNEW + strlen (HTML_MENOR);
        if (LENNEW >= SIZENEW) {SIZENEW = SIZENEW + INCMEM; pc = (char *)realloc (pc, (uint)SIZENEW);}
        strcat (pc, HTML_MENOR);
        break;
      case '"':
        LENNEW = LENNEW + strlen (HTML_DCOMILLAS);
        if (LENNEW >= SIZENEW) {SIZENEW = SIZENEW + INCMEM; pc = (char *)realloc (pc, (uint)SIZENEW);}        
        strcat (pc, HTML_DCOMILLAS);
        break;        
      case '%':
        LENNEW = LENNEW + strlen (HTML_PORC);
        if (LENNEW >= SIZENEW) {SIZENEW = SIZENEW + INCMEM; pc = (char *)realloc (pc, (uint)SIZENEW);}        
        strcat (pc, HTML_PORC);
        break;        
      default:
        LENNEW = LENNEW + 1;
        if (LENNEW >= SIZENEW) {SIZENEW = SIZENEW + INCMEM; pc = (char *)realloc (pc, (uint)SIZENEW);}      
        letra[0] = c;
        strcat (pc, letra);
        break;  
      }
    }
  res = pc;
  return res;  
  }  
  
bool IsEmpty (const char *pc)
  {
  if (pc == NULL) return true;
  if (strcmp (pc, "") == 0) return true;
  for (xuint i=0; i<strlen(pc); ++i)
    {
    char c;
    c = pc[i];
    if ((c != ' ') && (c != '\t')) return false;
    }
  return true;  
  }
  
bool IsNull (const char *pc)
  {
  if (pc == NULL) return true;
  if (strcmp (pc, "") == 0) return true;
  return false;  
  }  
  
bool IsGoodValidator (int cmd, int validator, int validatorgood)
  {
  if (validator == validatorgood) {return true;}
  if (
      (cmd == CMD_LOGOUT)   || (cmd == CMD_MB_INDEX) || (cmd == CMD_MB_SHOW)   ||
      (cmd == CMD_MB_CHANGE)|| (cmd == CMD_MB_CREATE)|| (cmd == CMD_CONF_ACT)  ||
      (cmd == CMD_CM)       || (cmd == CMD_CMNNTP)   || (cmd == CMD_CM_SEND)   || (cmd == CMD_CM_CANCEL) ||
      (cmd == CMD_OP)       || (cmd == CMD_OP_SAVE)  || (cmd == CMD_OP_CANCEL) ||
      (cmd == CMD_OP_NNTP)  || (cmd == CMD_OP_NNTP_SAVE)  || (cmd == CMD_OP_NNTP_CANCEL) ||
      (cmd == CMD_AB)       || 
      (cmd == CMD_AT_SHOW)  || (cmd == CMD_AT_SAVE)  || (cmd == CMD_AT_ERASE)  ||
      (cmd == CMD_CHECK_COOKIE)
     ) 
      {return true;}
  return false;
  }

void Ltrim (char *linea)
  {
  if (strlen (linea) <= 0) return;
  if (linea[0] != SP) return;
  char *p;
  xuint i, j = 0, ESPACIO = true, L;
  
  L = strlen (linea);
  p = strdup (linea);
  for (i = 0; i < strlen(linea); ++i)
    {
    if (ESPACIO == true)
      {
      if (linea[i] != SP) {ESPACIO = false; p[j] = linea[i]; ++j;}
      }
    else
      {
      p[j] = linea[i];
      ++j;
      }
    }
  p[j] = '\0';  
  strncpy (linea, p, L);  
  free (p);
  }
  
void Rtrim (char *linea)
  {
  int L;
  L = strlen (linea);
  if (L <= 0) return;
  if (linea[L - 1] != SP) return;
  int i, ESPACIO = true;
  i = L - 1;
  while ((i >= 0) && (ESPACIO == true)) 
    {
    if (linea [i] != SP) {ESPACIO = false; linea[i + 1] = '\0';}
    --i;
    }
  }
  
void trim  (char *linea)
  {
  Ltrim (linea);
  Rtrim (linea);
  }

//Delete spaces, \n, \r, \t from a pchar
void Rclean (char *linea)
  {
  int L;
  L = strlen (linea);
  if (L <= 0) return;
  int i, ADELANTE = true;
  i = L - 1;
  while ((i >= 0) && (ADELANTE == true)) 
    {
    if ((linea [i] != SP) && (linea [i] != '\n') && (linea [i] != '\r') && (linea [i] != '\t')) 
      {
      ADELANTE = false; linea[i + 1] = '\0';
      }
    --i;
    }
  }

const char *ForceSpace (const char *value)
  {
  if (IsEmpty(value)) return HTML_SP;
  else return value;
  }
  
char *Cut (const char *pc, int maxlong, TBuffer abuf)
  {
  strncpy (abuf, pc, CMAXBUFFER);
  if ((xuint)maxlong <= strlen(abuf))
    {
    abuf[maxlong] = '\0';
    }
  return abuf;
  }
  
char *CutSign (const char *pc, int maxlong, const char *signal, TBuffer abuf)
  {
  strncpy (abuf, pc, CMAXBUFFER);
  if ((xuint)maxlong <= strlen(abuf))
    {
    abuf[maxlong - strlen(signal)] = '\0';
    strcat (abuf, signal);
    }
  return abuf;
  }

//Coge un intervalo de lineas en el fichero entre x e y
char *getLineFile (const char *flname, int x, int y, TBuffer abuf)
  {
#define CMAXY 100000  
  TBuffer linea;
  FILE *fr;
  int cont, maxy;
  cont = 1;
  XString XS;
  XS = "";
  fr = fopen (flname, "r");
  if (fr == NULL) return "";
  maxy = y;
  if (maxy == -1) maxy = CMAXY;
  while ((fgets (linea, CMAXBUFFER, fr) != NULL) && (cont <= maxy))
    {
    if ((cont >= x) && (cont <= maxy))
      {
      if (maxy != CMAXY) QuitaRetornoCarroDeLinea (linea); 
      XS += linea;
      }
    ++cont;
    }
  fclose (fr);
  if (abuf == NULL)
    {
    return xstrdup (XS.cstr());
    }
  else
    {
    strncpy (abuf, XS.cstr(), CMAXBUFFER);
    return abuf;
    }
  }

void CreaFileSavedMsg (const char *fn)
  {
  FILE *FW;
  FW = fopen (fn, "w");
  fprintf (FW, "0\n");
  fprintf (FW, "\n");
  fprintf (FW, "\n");   
  fprintf (FW, "\n");   
  fprintf (FW, "\n");   
  fprintf (FW, "\n");
  fclose (FW);  
  }

char *MakeTmpName (TBuffer fntmp, int maxlong)
  {
  strncpy (fntmp, tempnam(TMP, NULL), maxlong);
  return fntmp;
  }

//Return true if the line will be cutted
bool ConcatLineToLineOfFile (const char *fn, int numlinea, const char *whatadd, const char *sep, int MAX) 
  {
  XString XS;
  int cont;
  bool res;
  FILE *FR, *FW;
  THBuffer linea; 
  TBuffer fntmp;
  MakeTmpName (fntmp, CMAXBUFFER);
  FR = fopen (fn, "r");
  FW = fopen (fntmp, "w");
  res = false;
  cont = 0;
  while (fgets (linea, CMAXHBUFFER, FR) != NULL)
    {
    ++cont;
    QuitaRetornoCarroDeLinea (linea);
    if (cont == numlinea)
      {
      if (!IsEmpty(linea))
        {
        XS  = linea;
        XS += sep;
        XS += whatadd;
        }
      else XS = whatadd;
      if (XS.length() > MAX) {res = true; XS.Cut (MAX);}
      fprintf (FW, "%s\n", XS.cstr());
      }
    else
      {
      fprintf (FW, "%s\n", linea);
      }
    }
  fclose (FW);
  fclose (FR);
  CopyFileOverWrite (fntmp, fn);
  DeleteFile (fntmp);
  return res;
  }
  
int CountChar (char *string, char tocount)
  {
  if (string == NULL) return 0;
  int cont = 0;
  for (xuint i=0; i < strlen(string); ++i)
    {
    if (string[i] == tocount) ++cont;
    }
  return cont;  
  }  
  
pid_t WritePidFile (void)
  {
  pid_t thepid;
  TSBuffer fn;
  FILE *FW;
  thepid = getpid ();
  sprintf (fn, "%s/%s.pid", PIDDIR, PROGNAME);
  FW = fopen (fn, "w");
  fprintf (FW, "%d\n", (unsigned)thepid);
  fclose (FW);     
  return thepid;
  }    
  
void DeletePidFile (void)
  {
  TSBuffer fn;
  sprintf (fn, "%s/%s.pid", PIDDIR, PROGNAME);
  DeleteFile (fn);
  }
  
void DelAllFilesFromDir (char *thedir)
  {
  DIR *dirp;
  struct dirent *dp;
  TBuffer abuf;

  dirp = opendir(thedir);
  if (dirp == NULL) return;
  while ((dp = readdir(dirp)) != NULL) 
    {
    if ((strcmp ("..", dp->d_name) != 0) && (strcmp (".", dp->d_name) != 0))
      {
      sprintf (abuf, "%s/%s", thedir, dp->d_name);
      DeleteFile (abuf);
      }
    }
  (void) closedir(dirp);
  }
  
char *getMailcapTipoFromFilename (const char *fn, const char *fnmailcap)
  {
  if (fn == NULL) return "";
  LINEA linea, exts, tipo, miext;
  FILE *FR;
  FR = fopen (fnmailcap, "r");
  if (FR == NULL) 
    {
    LOG ("Error: Can not open mailcap file:'%s'", fnmailcap);
    return "";
    }
  initStr(miext, "."); strcat (miext, getExtensionFromFile (fn)); strcat (miext, ".");
  while (fgets (linea, MAXLENGTHLINE, FR) != NULL) 
    {   
    sscanf (linea, "%s %s", exts, tipo);
    if (NCstrstr (exts, miext) > 0)
      {
      fclose (FR);
      return strdup(tipo);
      }
    }
  fclose (FR);
  return "";
  } 

void PrintHomePage (char *lang)
  {
  if (strcmp (lang, "spa") == 0) DumpHTMLPage (HOMEPAGE_SPA);
  else if (strcmp (lang, "val") == 0) DumpHTMLPage (HOMEPAGE_VAL);
  else if (strcmp (lang, "eus") == 0) DumpHTMLPage (HOMEPAGE_EUS);  
  else DumpHTMLPage (HOMEPAGE_ENG);
  }  

void DumpHTMLPage (char *fn)
  {
  if (fn == NULL) return;
  LINEA linea;
  char c, CHARCOMMAND = '^';
  
  printf ("Pragma: no-cache\n");
  printf ("Cache-Control: no-cache\n");
  printf ("Expires: Thu, 01 Dec 1994 16:00:00 GMT\n");
  printf ("Content-type: text/html\n\n");    
  FILE *FR;
  FR = fopen (fn, "r");
  if (FR == NULL) return;
  while (fgets (linea, MAXLENGTHLINE, FR) != NULL) 
    {   
    if (strcmp (linea, "") != 0)
      {
      c = linea[0];
      if (c == CHARCOMMAND)
        {
        TSBuffer charcommand, command, afn;
        sscanf (linea, "%s %s %s", charcommand, command, afn);
        if (strcmp (command, "INC") == 0)
          {
          FILE *f;
          TBuffer abuf;
          if (FileExists (afn) == true)
            {
            f = fopen (afn, "r");
            if (f != NULL)
              {
              while (fgets (abuf, CMAXBUFFER, f) != NULL)
                {
                printf ("%s", abuf);
                }
              fclose (f);
              }
            }  
          }
        }
      else
        {
        printf (linea);
        }
      }
    }
  fclose (FR);
  }
          
long min (long i,long j)
  {
  return ((i < j) ? i : j);
  }

void XTICK (char *label)
  {
  static struct tms T0 = {0,0,0};
  struct tms T1;
  times (&T1); 
  if (label != NULL) {LOG ("%s TIME WASTED: User=%ld System=%ld", label, T1.tms_utime - T0.tms_utime, T1.tms_stime - T0.tms_stime);}
  T0 = T1;
  }

void PChar2SL (char *chunk, StringList *SL)
  {
  int cont, i;
  char c, letra[2];
  XString Ad;
  letra[1] = '\0';
  SL->Clear();
  Ad = "";
  cont = -1;
  for (i = 0; i < (xsint)strlen(chunk); ++i)
    {
    ++cont;
    c = chunk[i]; 
    letra[0] = c;
    switch (c)
      {
      case '\t':
      case ' ':
           {
           if (cont == 0)
             {
             Ad = SL->getString(SL->Count() - 1);
             Ad.Cut (Ad.length() - 2);
             SL->removeElementAt (SL->Count() - 1);
             }
           else
             {
             Ad += " ";
             if (i == (xsint)strlen(chunk) - 1) 
               {
               Ad += "\r\n"; 
               SL->Add(Ad);
               }
             }  
           break;
           }
      case '\r': 
           break;
      case '\n': 
           cont = -1;
           Ad += "\r\n";
           SL->Add(Ad);
           Ad = "";        
           break;
      default:
           Ad += letra;
           if (i == (xsint)strlen(chunk) - 1) 
             {
             Ad += "\r\n"; 
             SL->Add(Ad);
             }
           break;
      }
    }
  int pos = -1;  
  for (i = 0; i < SL->Count(); ++i)
    {
    Ad = XString(SL->getString(i)).toUpperCase();
    if (strstr(Ad.cstr(), "CONTENT-TRANSFER-ENCODING:") != NULL) pos = i;
    }      
  if (pos > -1) SL->removeElementAt (pos);  
  }
                
void ResaltaURLsEnText (char *txt, XSocket *aXS, int MaxLongLine, bool IsUencoded, TBuffer urltouudecode)
  {
  const unsigned int MAXPALABRA = 1000;
  int INCR, sizeorig, contlonglinea, cont_uuencoded = 0;
  int pos_initxt;
  char c, letra[2], palabra[MAXPALABRA];
  TBuffer abuf;
  bool BeginUencodedAlcanzado = false, RecienAlcanzadoEndUuencoded = false;

  sizeorig = strlen (txt);
  INCR = (int)((float)sizeorig * (float)(5.0 / 100.0));  if (INCR <= 1000) INCR = 1000;
  letra[1] = '\0';
  palabra[0] = '\0';
  contlonglinea = 0;
  for (pos_initxt = 0; pos_initxt < sizeorig; ++pos_initxt)
    {
    ++contlonglinea;
    if (IsMultiplo (contlonglinea, MaxLongLine) == true) {contlonglinea=0; aXS->Write ("\n", 1);}
    c = txt[pos_initxt];
    switch (c)
      {
      case '\r':
      case '\n': contlonglinea = 0;
      case ' ' :
      case '\t':
      case '(' :
      case ')' :
      case '<' :
      case '>' :
      //There are urls with that char-->   case ',' :
      case '\"':
        {
        if (strlen(palabra) > 0)
          {
          if (IsUencoded == true)
            {
            if (((strcmp (palabra, "begin") == 0) && (BeginUencodedAlcanzado == false)) ||
                ((strcmp (palabra, "begin-base64") == 0) && (BeginUencodedAlcanzado == false)))
              {
              ++cont_uuencoded;
              
              TBuffer linea, abuf2, abuf3;
              int ppos, mode;
              char c2, letra2[2];
              
              letra2[1] = '\0';
              strcpy (linea, "");
              ppos = pos_initxt; 
              c2 = txt[ppos]; letra2[0] = c2;
              while ((ppos < sizeorig) && (c2 != '\n'))
                {
                strcat (linea, letra2);
                ++ppos;
                c2 = txt[ppos];
                letra2[0] = c2;
                }
              sscanf (linea, "%o %[^]]s", &mode, abuf2);  
              
              sprintf (abuf3, L->get(L_DISPLAY_UUENCODED), abuf2);
              BeginUencodedAlcanzado = true;
              sprintf (abuf, "%s%d/\">%s</A><BR>\n", urltouudecode, cont_uuencoded, abuf3);
              aXS->Write (abuf, (uint)strlen(abuf));
              }
            if ((strcmp (palabra, "end") == 0) && (BeginUencodedAlcanzado == true))
              {
              BeginUencodedAlcanzado = false;
              RecienAlcanzadoEndUuencoded = true;
              }                            
            }
          if ((strncasecmp (palabra, "http://",  7) == 0)  || (strncasecmp (palabra, "ftp://",  6) == 0) ||
              (strncasecmp (palabra, "https://", 8) == 0)  || (strncasecmp (palabra, "mailto:", 7) == 0) ||
              (strncasecmp (palabra, "news://",  7) == 0))
            {
            sprintf (abuf, "<A HREF=\"%s\">%s</A>", palabra, palabra);
            }           
          else 
            {
            strncpy (abuf, palabra, CMAXBUFFER);
            }
          if (BeginUencodedAlcanzado == false) 
            {
            if (RecienAlcanzadoEndUuencoded == false) aXS->Write (abuf, (uint)strlen(abuf)); 
            RecienAlcanzadoEndUuencoded = false;
            }
          }
        if (c == '<')
          {
          if (BeginUencodedAlcanzado == false) aXS->Write (HTML_MENOR, (uint)strlen(HTML_MENOR));
          }
        else if (c == '>')
          {
          if (BeginUencodedAlcanzado == false) aXS->Write (HTML_MAYOR, (uint)strlen(HTML_MAYOR));
          }
        else
          {    
          letra[0] = c; 
          if (BeginUencodedAlcanzado == false) aXS->Write (letra, (uint)strlen(letra));
          }
        palabra[0] = '\0';          
        break;
        }
      default:
        {                  
        if (strlen(palabra) >= MAXPALABRA - 1)
          {
          if ((strncasecmp (palabra, "http://",  7) == 0)  || (strncasecmp (palabra, "ftp://",  6) == 0) ||
              (strncasecmp (palabra, "https://", 8) == 0)  || (strncasecmp (palabra, "mailto:", 7) == 0) ||
              (strncasecmp (palabra, "news://",  7) == 0))
            {
            sprintf (abuf, "<A HREF=\"%s\">%s</A>", palabra, palabra);
            }
          else strncpy (abuf, palabra, CMAXBUFFER);
          if (BeginUencodedAlcanzado == false) aXS->Write (abuf, (uint)strlen(abuf)); 
          palabra[0] = '\0';
          }
        letra[0] = c; strcat (palabra, letra);
        break;
        }
      }
    }  
  if (strlen(palabra) > 0)
    {
    if ((strncasecmp (palabra, "http://",  7) == 0)  || (strncasecmp (palabra, "ftp://",  6) == 0) ||
        (strncasecmp (palabra, "https://", 8) == 0)  || (strncasecmp (palabra, "mailto:", 7) == 0) ||
        (strncasecmp (palabra, "news://",  7) == 0))
      {
      sprintf (abuf, "<A HREF=\"%s\">%s</A>", palabra, palabra);
      }
    else strncpy (abuf, palabra, CMAXBUFFER);
    aXS->Write (abuf, (uint)strlen(abuf));
    }
  }  
    
//Devuelve true si dividendo es un multiplo de divisor
bool IsMultiplo (int dividendo, int divisor)
  {
  if (dividendo % divisor == 0.0) return true;
  else return false;
  }  
  
//Una implementation, ma o menos, de sscanf para que separe los tokens con quoting ""
void xscanf (const char *linea, 
             char *c0,
             int *int1, int *int2, int *int3, 
             char *c1, char *c2, char *c3, char *c4, char *c5, char *c6, char *c7, char *c8)
  {
#define MODO_COM 0
#define MODO_ESP 1  
  TBuffer palabra;
  char c, letra[2];
  int L, i, MODO;
  StringList *SL;    
  
  MODO = MODO_ESP;
  letra[1] = '\0';
  initStr (palabra);
  SL  = new StringList ();
  L = strlen (linea);
  for (i=0; i<L; ++i)
    {
    c = linea[i]; 
    letra[0] = c;
    switch (c)
      {
      case '\"': 
        {
        if (MODO == MODO_COM)
          {
          if (strcmp (palabra, "") != 0) 
            {
            SL->Add(palabra);
            initStr (palabra);
            }
          MODO = MODO_ESP;  
          }
        else 
          {
          MODO = MODO_COM;
          }        
        break;
        }
      case ' ': 
        {
        if (MODO == MODO_ESP)
          {
          if (strcmp (palabra, "") != 0) 
            {
            SL->Add(palabra);
            initStr (palabra);
            }
          }
        else {strcat (palabra, letra);}
        break;
        }
      default:
        {
        strcat (palabra, letra);               
        }
      }
    }
  if (strcmp (palabra, "") != 0) {SL->Add(palabra);}  
    
  for (i = 0; i < SL->Count(); ++i)
    {
    switch (i)
      {                                                                                  
      case  0: strncpy (c0, SL->getString(i).cstr(), CSMALLBUFFER); break;                    
      case  1: *int1 = xatoidef (SL->getString(i).cstr(), 0); break;
      case  2: *int2 = xatoidef (SL->getString(i).cstr(), 0); break;              
      case  3: *int3 = xatoidef (SL->getString(i).cstr(), 0); break;              
      case  4: if (c1 != NULL) {strncpy (c1, SL->getString(i).cstr(), CSMALLBUFFER);} break;        
      case  5: if (c2 != NULL) {strncpy (c2, SL->getString(i).cstr(), CSMALLBUFFER);} break;                      
      case  6: if (c3 != NULL) {strncpy (c3, SL->getString(i).cstr(), CSMALLBUFFER);} break;                      
      case  7: if (c4 != NULL) {strncpy (c4, SL->getString(i).cstr(), CSMALLBUFFER);} break;                      
      case  8: if (c5 != NULL) {strncpy (c5, SL->getString(i).cstr(), CSMALLBUFFER);} break;              
      case  9: if (c6 != NULL) {strncpy (c6, SL->getString(i).cstr(), CSMALLBUFFER);} break;              
      case 10: if (c7 != NULL) {strncpy (c7, SL->getString(i).cstr(), CSMALLBUFFER);} break;              
      case 11: if (c8 != NULL) {strncpy (c8, SL->getString(i).cstr(), CSMALLBUFFER);} break;                    
      }
    }  

  delete SL;
  }  
  
char *ProcesaDate (char *tmp, TBuffer abuf)
  {
  char c, letra[2];
  int L, i, cont, nowyear, dateyear;
  TSBuffer nuevafecha, dia, mes, anyo, resto;
  time_t now; 
  struct tm *xtm;  
  now = time (NULL);
  xtm = localtime (&now);
  nowyear = xtm->tm_year + 1900;
  letra[1] = '\0';
  L = strlen (tmp);
  cont = 0;
  initStr(nuevafecha); initStr (dia), initStr (mes); initStr (anyo); initStr(resto);

  for (i = 0; i < L; ++i)
    {
    c = tmp[i];
    letra[0] = c;
    if (c == '-') {++cont;}                   // Count the hyphens in " 8-Sep-2000"
    else if ((c == ' ') && (i > 0)) {++cont;} // Skip any spaces, but not if it was in tmp[0].
                                        // For the first space, insert two &nbsp;
                                        // This used to be one &nbsp; but with proportional
                                        // spaced fonts, I find two spaces is about the
                                        // same width as a printable character space. 
    else if ((c == ' ') && (i == 0))
      {  
      strcat (dia, HTML_HSP);
      strcat (dia, HTML_HSP);
      } 
    else
      {
      switch (cont)
        {
        // Collect the day, month and year in separate strings.
        case 0: strcat (dia, letra); break; 
        case 1: strcat (mes, letra); break; 
        case 2: strcat (anyo, letra); break; 
        // Collect everything else here: 08:51:13+0100
        default: strcat (resto, letra); break; 
        }
      }
    }
  dateyear = xatoidef ((const char *)anyo, 2000);  

  strcat (nuevafecha, dia);  
  strcat (nuevafecha, "-"); 
  strcat (nuevafecha, mes); 
                
  // If the message is not from this year, output the year preceded by "-".  
  if (nowyear != dateyear) 
    {
    strcat (nuevafecha, "-"); 
    strcat (nuevafecha, anyo); 
    }
  else
    {
    // Now we want to output the first 5 chars of everything else, which is typically
    // the time, but first output two spaces.
    if (DISPLAY_MSG_TIME_IN_INDEX == 1)
      {
      strcat  (nuevafecha, HTML_HSP);
      strcat  (nuevafecha, HTML_HSP);
      strcat  (nuevafecha, "("); strncat (nuevafecha, resto, 5); strcat  (nuevafecha, ")");
      // To give a bit of white space at the end of this busy date section, and so to make
      // it easier to read the From section, add four non-breaking spaces.
      strcat  (nuevafecha, HTML_HSP);    
      strcat  (nuevafecha, HTML_HSP);    
      strcat  (nuevafecha, HTML_HSP);    
      strcat  (nuevafecha, HTML_HSP);    
      }
    }
  strncpy (abuf, nuevafecha, CMAXBUFFER);  
  return abuf;
  }  
  
int GetBufferFromFile (char *afile, char *abuf, int maxlength)
  {
  TBuffer linea;
  int cont = 0;
  FILE *fr;
  
  initStr (abuf);
  fr = fopen (afile, "r");
  if (fr == NULL) {return 0;}
  while (fgets (linea, CMAXBUFFER, fr) != NULL)
    {
    cont = cont + strlen (linea);
    if (cont < maxlength) {strcat (abuf, linea);}
    else {fclose (fr); return cont - strlen (linea);}
    }
  fclose (fr);  
  return cont;
  }
  
char *bool2char (bool b)
  {
  if (b == true) return "1"; else return "0";
  }
  
bool char2bool (char *c)
  {
  if (c == NULL) return false;
  if (strcmp (c, "0") == 0) return false; else return true;  
  }  

char *DisplayFlags (const char *flags, bool clickable, const char *molde, int show_way, TBuffer abuf)
  {
  XString XS;
  char c;
  TBuffer tmpbuf;
  
  //show_way = 0: All flags
  //show_way = 1: Active flags
  //show_way = 2: Inactive flags
  
  XS = HTML_HSP; XS += "\n";
  for (xuint i=0; i < strlen (flags); ++i)
    {
    c = flags[i];
    if (i == POS_FLAG_DELETED)
      {
      if ((c == FDELETED) && ((show_way == 0) || (show_way == 1)))
        {
        if (clickable)
          {
          sprintf (tmpbuf, "<A HREF=\"%s/mg_fg_undelete/noop/%s", PATH_POSTMAN, molde);
          XS += tmpbuf;
          }
        XS += "<IMG BORDER=\"0\" SRC=\""; XS += IMG_FLAG_DELETED; XS += "\" ALT=\"("; XS += L->get(L_FLAG_DELETED); XS += ")\">";
        if (clickable) XS += "</A>\n";
        }
      else
        {  
        if ((c == FEMPTY) && (clickable) && ((show_way == 0) || (show_way == 2)))
          {
          sprintf (tmpbuf, "<A HREF=\"%s/mg_fg_delete/noop/%s", PATH_POSTMAN, molde);
          XS += tmpbuf;
          XS += "<IMG BORDER=\"0\" SRC=\""; XS += IMG_FLAG_UNDELETED; XS += "\" ALT=\"("; XS += L->get(L_FLAG_UNDELETED); XS += ")\">";
          XS += "</A>\n";
          }
        }
      }
    else if (i == POS_FLAG_SEARCHED)
      {
      if ((c == FSEARCHED) && ((show_way == 0) || (show_way == 1)))
        {
        if (clickable)
          {
          sprintf (tmpbuf, "<A HREF=\"%s/mg_fg_unsearched/noop/%s", PATH_POSTMAN, molde);
          XS += tmpbuf;                                           
          }
        XS += "<IMG BORDER=\"0\" SRC=\""; XS += IMG_FLAG_SEARCHED; XS += "\" ALT=\"("; XS += L->get(L_FLAG_SEARCHED); XS += ")\">";        
        if (clickable) XS += "</A>\n";
        }
      else
        {  
        if ((c == FEMPTY) && (clickable) && ((show_way == 0) || (show_way == 2)))
          {
          sprintf (tmpbuf, "<A HREF=\"%s/mg_fg_searched/noop/%s", PATH_POSTMAN, molde);
          XS += tmpbuf;
          XS += "<IMG BORDER=\"0\" SRC=\""; XS += IMG_FLAG_UNSEARCHED; XS += "\" ALT=\"("; XS += L->get(L_FLAG_UNSEARCHED); XS += ")\">";    
          XS += "</A>\n";
          }
        }
      }                                                                 
    else if (i == POS_FLAG_ANSWERED)
      {
      if ((c == FANSWERED) && ((show_way == 0) || (show_way == 1)))
        {  
        if (clickable)
          {
          sprintf (tmpbuf, "<A HREF=\"%s/mg_fg_unanswered/noop/%s", PATH_POSTMAN, molde);
          XS += tmpbuf;
          }
        XS += "<IMG BORDER=\"0\" SRC=\""; XS += IMG_FLAG_ANSWERED; XS += "\" ALT=\"("; XS += L->get(L_FLAG_ANSWERED); XS += ")\">";        
        if (clickable) XS += "</A>\n";
        }
      else
        {  
        if ((c == FEMPTY) && (clickable) && ((show_way == 0) || (show_way == 2)))
          {
          sprintf (tmpbuf, "<A HREF=\"%s/mg_fg_answered/noop/%s", PATH_POSTMAN, molde);
          XS += tmpbuf;
          XS += "<IMG BORDER=\"0\" SRC=\""; XS += IMG_FLAG_UNANSWERED; XS += "\" ALT=\"("; XS += L->get(L_FLAG_UNANSWERED); XS += ")\">";    
          XS += "</A>\n";
          }
        }
      }                                                 
    else if (i == POS_FLAG_IMPORTANT)
      {
      if ((c == FFLAGGED) && ((show_way == 0) || (show_way == 1)))
        {
        if (clickable)
          {
          sprintf (tmpbuf, "<A HREF=\"%s/mg_fg_unflagged/noop/%s", PATH_POSTMAN, molde);
          XS += tmpbuf;
          }
        XS += "<IMG BORDER=\"0\" SRC=\""; XS += IMG_FLAG_FLAGGED; XS += "\" ALT=\"("; XS += L->get(L_FLAG_FLAGGED); XS += ")\">";        
        if (clickable) XS += "</A>\n";
        }
      else
        {  
        if ((c == FEMPTY) && (clickable) && ((show_way == 0) || (show_way == 2)))
          {
          sprintf (tmpbuf, "<A HREF=\"%s/mg_fg_flagged/noop/%s", PATH_POSTMAN, molde);
          XS += tmpbuf;
          XS += "<IMG BORDER=\"0\" SRC=\""; XS += IMG_FLAG_UNFLAGGED; XS += "\" ALT=\"("; XS += L->get(L_FLAG_UNFLAGGED); XS += ")\">";      
          XS += "</A>\n";
          }
        }
      }
    else if ((i == POS_FLAG_NEW) && (clickable == false))
      {
      if (((c == FNEW) || (c == FUNSEEN)) && ((show_way == 0) || (show_way == 1)))
        {
        if (clickable)
          {
          sprintf (tmpbuf, "<A HREF=\"%s/mg_fg_seen/noop/%s", PATH_POSTMAN, molde);
          XS += tmpbuf;
          }
        XS += "<IMG BORDER=\"0\" SRC=\""; XS += IMG_FLAG_UNSEEN; XS += "\" ALT=\"("; XS += L->get(L_FLAG_UNSEEN); XS += ")\">";
        if (clickable) XS += "</A>\n";
        }
      else
        {  
        if ((c == FEMPTY) && (clickable) && ((show_way == 0) || (show_way == 2)))
          {
          sprintf (tmpbuf, "<A HREF=\"%s/mg_fg_unseen/noop/%s", PATH_POSTMAN, molde);
          XS += tmpbuf;
          XS += "<IMG BORDER=\"0\" SRC=\""; XS += IMG_FLAG_SEEN; XS += "\" ALT=\"("; XS += L->get(L_FLAG_SEEN); XS += ")\">";
          XS += "</A>\n";
          }
        }
      }
    }   
  strncpy (abuf, XS.cstr(), CMAXBUFFER);
  return abuf;
  }  

int getNumChilds (void)
  {
  int ires;
  FILE *FR;
  char abuf[500 + 1];

  strcpy (abuf, "");
  FR = popen(CMDNUMCHILDS, "r");
  if (FR != NULL)
    {
    //Only must get one line.
    while (fgets (abuf, 500, FR) != NULL) {/*NOTHING HERE*/};
    pclose (FR);
    FR = fopen (TMPSERVERCOUNT, "r");
    if (FR == NULL) {LOG ("Error opening '%s'", TMPSERVERCOUNT); return -1;}
    fgets (abuf, 500, FR);
    fclose (FR);
    QuitaRetornoCarroDeLinea(abuf);
    trim(abuf);
    ires = xatoidef (abuf, -1);
    }
  else 
    {
    ires = -1; 
    LOG ("Error haciendo popen!\n");
    }
  return ires;
  }
  
int SeparaTokensEnStringList (const char *pc, const char sep, StringList *SL)
  {
  XString XS;
  char c; 
  int counter = 0;
  
  SL->Clear();
  XS = "";
  for (int i = 0; (unsigned int)i < strlen(pc); ++i)
    {
    c = pc[i];
    if (c == sep)
      {   
      if (XS.length() > 0) {++counter; SL->Add (XS.cstr());}
      XS = "";
      }
    else
      {
      XS += c;
      }
    }
  if (XS.length() > 0) {++counter; SL->Add (XS.cstr());}
  return counter;
  }  
  
int CountTokensEnString (const char *pc, const char sep)
  {
  XString XS;
  char c; 
  int counter = 0;
  
  for (int i = 0; (unsigned int)i < strlen(pc); ++i)
    {
    c = pc[i];
    if (c == sep)
      {   
      if (XS.length() > 0) {++counter;}
      XS = "";
      }
    else
      {
      XS += c;
      }
    }
  if (XS.length() > 0) {++counter;}
  return counter;
  }    
  
//Extract addresses cutting by <>. Gap is ,
void ExtraeAddresses (StringList *SL, char *linea, bool ClearSL)
  {
  int menor, mayor;
  char c, letra[2];
  XString Ad;
  letra[1] = '\0';
  if (ClearSL == true) {SL->Clear();}
  Ad = "";
  for (int i = 0; i < (xsint)strlen(linea); ++i)
    {
    c = linea[i]; 
    letra[0] = c;
    switch (c)
      {
      case ',': 
           if (Ad.length() > 0) 
             {
             menor = Ad.indexOf ('<'); mayor = Ad.indexOf ('>');
             if ((menor >= 0) && (mayor >= 0)) {SL->Add(Ad.substring(menor, mayor + 1));}
             else SL->Add(Ad);
             Ad = "";        
             }
           break;
      default:
           Ad += letra;
           break;
      }
    }
  if (Ad.length() > 0) 
    {
    menor = Ad.indexOf ('<'); mayor = Ad.indexOf ('>');
    if ((menor >= 0) && (mayor >= 0)) {SL->Add(Ad.substring(menor, mayor + 1));}
    else SL->Add(Ad);
    Ad = "";            
    }
  }  
  
//Extract full addresses. Gap is ,
void ExtraeFullAddresses (StringList *SL, const char *linea, bool ClearSL)
  {
  char c, lastletra, letra[2];
  XString Ad;
  letra[1] = '\0';
  if (ClearSL == true) {SL->Clear();}
  Ad = "";
  lastletra = ' '; c = ' ';
  for (int i = 0; i < (xsint)strlen(linea); ++i)
    {
    lastletra = c;
    c = linea[i]; 
    if ((c != ' ') || (lastletra != ' '))
      {
      letra[0] = c;
      switch (c)
        {
        case ',': 
             if (Ad.length() > 0) 
               {
               if (SL->indexOf(Ad) < 0) {SL->Add(Ad);}
               Ad = "";        
               }
             break;
        default:
             Ad += letra;
             break;
        }
      }  
    }
  if (Ad.length() > 0) 
    {
    if (SL->indexOf(Ad) < 0) {SL->Add(Ad);}
    Ad = "";            
    }
  }    
  
//Must I show the ReplyAll button?
bool MustDoReplayAll (const char *ato, const char *afrom, const char *areplyto, const char *acc)
  {
  if (((strcmp(areplyto, "") != 0) && (strcmp (areplyto, afrom) != 0)) || 
      (strcmp(acc, "") != 0) || 
      (strchr (ato, ',') != NULL))
    return true;
  else
    return false;  
  }

//Reply to fields FROM, REPLYTO, CC and TO multiples
char *getReplyAllAddresses (const char *ato, const char *afrom, const char *areplyto, const char *acc)
  {
  StringList SL;
  XString AllAddresses;
  
  ExtraeFullAddresses (&SL, afrom, false);
  if (strchr (ato, ',') != NULL) {ExtraeFullAddresses (&SL, ato, false);}
  if (strcmp (areplyto, afrom) != 0) {ExtraeFullAddresses (&SL, areplyto, false);}
  ExtraeFullAddresses (&SL, acc, false);
  for (int i=0; i<SL.Count(); ++i) 
    {
    if (AllAddresses.length() + strlen (SL.getString(i).cstr()) + 1 < MAXLENGTH_TO)
      {
      AllAddresses += SL.getString(i).cstr(); 
      if (i < SL.Count() - 1) {AllAddresses += ",";}
      }
    }
  return xstrdup (AllAddresses.cstr());   
  } 
  
int xvsnprintf(char *str, size_t size, const char *fmt, va_list ap)
  {
#ifdef HAVE_VSNPRINTF  
  return vsnprintf(str, size, fmt, ap);
#else
  return vsprintf(str, fmt, ap);
#endif
  }

int xsnprintf(char *str, size_t size, const char *fmt, ...)
  {
  int ret;
  va_list args;
  va_start (args, fmt);
#ifdef HAVE_VSNPRINTF  
  ret = vsnprintf(str, size, fmt, args);
#else
  ret = vsprintf(str, fmt, args);
#endif
  va_end (args);
  return ret;
  }
  
void DisableHTMLTokens (char *htmltxt)
  {
  char *pc;
  pc = strstr (htmltxt, "<HTML>");  if (pc != NULL) {htmltxt[pc - htmltxt + 1] = 'x';}
  pc = strstr (htmltxt, "<BODY ");  if (pc != NULL) {htmltxt[pc - htmltxt + 1] = 'x';}  
  pc = strstr (htmltxt, "</BODY>"); if (pc != NULL) {htmltxt[pc - htmltxt + 2] = 'x';}    
  pc = strstr (htmltxt, "</HTML>"); if (pc != NULL) {htmltxt[pc - htmltxt + 2] = 'x';}  
  }

// Expect something like:
// 2 APPLICATION/OCTET-STREAM 27326 bytes, "This is a comment", "SYSTEM 3.doc"
// and we want to return the last field

#define SKIP_TO(c) while(*str && *str != c) { str++; }
#define SPAN_CHAR(c) while(*str && *str == c) { str++; }

char *get_filename (const char *str)
  {
  const char *holder;
  char *filename;
  uint i;
  int j;
  
  char nmsg[] = "message.txt";
  filename = (char *)malloc(sizeof(nmsg) + 1);
  for(i=0; i < sizeof(nmsg); i++)
    {
    filename[i] = nmsg[i];
    }
  filename [sizeof(nmsg) + 1] = '\0';  

  // this breaks if the filename has a comma!!
  str = strrchr(str, ',');              // find the last field seperator
  if (str == NULL) return filename;     //If no commas exist lets exit
  if (*str != ',') return filename;     // bogus input
  str++;                                // go past the comma

  SPAN_CHAR(' ');                       // skip any leading space
  if (*str == '\0') return filename;
  
  if(*str == '"'){
    str++;                      
    holder = str;                       // remember the start of the filename
    
    SKIP_TO('"');                       // find the end of the quoted filename
    if (*str == '\0') return filename;
    if (holder == str)  return filename; // empty quoted filename (bug?)
    } else {
    // not a quoted string, use up to comma
    holder = str;                       // remember the start of the filename
    SKIP_TO(',');                       // find the end of plain string
                                        // may be end of input string
    }
                        
  if (str-holder >= MAX_FILENAME_SIZE) return filename;

  free((void *)filename);               // release the error string
  filename = (char *) malloc ((str-holder+1) * sizeof(char));
  if (filename == NULL) return "NULL";
  for (j = 0; j < str-holder; j++)
    {
    filename[j] = holder[j];
    }

  filename[str-holder] = '\0';             // make sure string is null terminated
  return filename; 
  }

//Merge two StringList in one 
int MergeStringList (StringList *SLBase, StringList *SL2Merge, bool check_exists)
  {
  int counter = 0;
  for (int i = 0; i < SL2Merge->Count (); ++i)
    {
    if (check_exists == true) //TO AVOID DUPLICATES
      {
      //DEBUG ("--%s--", SL2Merge->getString(i).cstr());
      if (SLBase->indexOf(SL2Merge->getString(i).cstr()) == -1) 
        {
        ++counter;
        SLBase->Add (SL2Merge->getString(i).cstr());
        }
      }
    else
      {
      ++counter;
      SLBase->Add (SL2Merge->getString(i).cstr());
      }
    }
  return counter;  
  }

//Routine for display memory usage.
void MEMLOG (char *LineInfo)
  {
  StringList *SL;
  TBuffer procfn, linea;
  int pid;
  FILE *FR;
  
  pid = getpid();
  sprintf (procfn, "/proc/%d/status", pid);
  SL = new StringList ();  
  FR = fopen (procfn, "r");
  while (fgets (linea, CMAXBUFFER, FR) != NULL) {SL->Add (linea);}
  fclose (FR);
  DEBUG ("%s", LineInfo);
  /*
  VmSize:   3724 kB
  VmLck:       0 kB
  VmRSS:    1664 kB
  VmData:    536 kB
  VmStk:      84 kB
  VmExe:     992 kB
  VmLib:    1992 kB
  */
  for (int i=0; i < SL->Count(); ++i)
    {
    if ((NCstrstr (SL->getString(i).cstr(), "VmSize") > 0)  ||
        (NCstrstr (SL->getString(i).cstr(), "VmRSS")  > 0)  ||
        (NCstrstr (SL->getString(i).cstr(), "VmData") > 0))
      {
      DEBUG ("   pid=%d, %s", pid, SL->getString(i).cstr());
      }
    }
  delete SL;    
  }
 
int string_matching (const char *s, const char *w, int slen)
  {
  while (*w)
    {
    if (*s == 0)
      {
      if (*w == '*')
        {
        w++;
        continue;
        }
      return 0;
      }
    else if (*w == *s)
      {
      w++;
      s++;
      slen--;
      }
    else if (*w == '#')
      {
      if (*s == 0) return 0;
      if (*s >= '0' && *s <= '9')
        {
        s++;
        slen--;
        w++;
        }
      else return 0;
      }
    else if (*w == '?')
      {
      if (*s == 0) return 0;
      s++;
      slen--;
      w++;
      }
    else if (*w == '*')
      {
      w++;
      if (*w == 0) return 1;
      while (*w)
        {
        if (string_matching(s, w, slen)) return 1;
        if (slen == 0 || *s == 0) break;
        s++;
        slen--;
        }
      break;
      }
    else return 0;
    }
  if (*w != 0) return 0;
  if (slen != 0 && *s != 0) return 0;
  return 1;
  }

bool StringsLike (const char *text, const char *wildcard)
  {
  /*usage: if (StringsLike("gtestasdfasdf", "?test*")) printf ("matching"); else printf ("not matching");*/    
  if (!text || !wildcard) return false;
  if (string_matching(text, wildcard, strlen(text)) == 0) return false; else return true;
  }

bool SavePchar (const char *pc, int len, const char *fn)
  {
  int fd;
  fd = open (fn, O_WRONLY | O_CREAT, 0600);
  if (fd < 0) return false;
  if (write (fd, pc, len) != len) return false;      
  if (close (fd) != 0) return false;
  return true;
  } 
 
